﻿using System;
using System.Collections.Generic;

namespace EsempioFlyweight
{
    public class FileDescriptor : IPanelItem  //  Cliente
    {
        private readonly string _name;
        private readonly string _type;
        private IFlyweight _icon = null;

        public FileDescriptor(string name, string type)
        {
            _name = name;
            _type = type;
            //_icon = FlyweightFactory.GetFlyweight(type);
        }

        public string Name
        {
            get { return _name; }
        }

        public string Type
        {
            get { return _type; }
        }

        public IFlyweight Icon
        {
            get
            {
                if (_icon == null)
                {
                    _icon = FlyweightFactory.GetFlyweight(Type);
                }
                return _icon;
            }
        }

        #region IPanelItem Members

        public int Width
        {
            get { return Icon.Width + NameLength; }
        }

        public int Height
        {
            get { return Icon.Height; }
        }

        public void Draw(int x, int y)
        {
            Console.Write("   drawing {0}", Name);
            Icon.Draw(x, y);
        }

        private int NameLength
        {
            get { return Name.Length * 5; }
        }

        #endregion
    }
}
