﻿using System;
using System.Collections.Generic;

namespace EsempioFlyweight
{
    public class Panel
    {
        private readonly List<IPanelItem> _panelItems = new List<IPanelItem>();

        public void Add(IPanelItem panelItem)
        {
            _panelItems.Add(panelItem);
        }

        public void Draw()
        {
            Draw(0, 0, 10);
        }

        public void Draw(int x, int y, int deltaX)
        {
            foreach (IPanelItem panelItem in _panelItems)
            {
                panelItem.Draw(x, y);
                x += panelItem.Width + deltaX;
            }
        }
    }
}
